(load "opcode.scm")

;(define program #((movlw 0) (tris 6) (clrf 6) (clrf 12) (movf 12 0) (movwf 6) (call 9) (incf 12 1) (goto 4) (movlw 31) (movwf 14) (movlw 31) (movwf 13) (decfsz 13 1) (goto 13) (decfsz 14 1) (goto 11) (return) (end)))

(define assemble
  (lambda (prog)    ; prog is a scheme code transformed asm program
    (letrec ((iter (lambda (line bin-code)
                     (let ((code (vector-ref prog line)) (new-code ""))
                       (if (or (= line (- (vector-length prog) 1)) (equal? 'end (car code)))
                           #t
                           (if (equal? (string-ref (symbol->string (car code)) 0) #\b)
                               (set! new-code (string-append (cadr (assoc (car code) bitOps))
                                                             (binary-string (cadr code) 7)
                                                             (binary-string (caddr code) 3)))
                               (let ((byteop (assoc (car code) byteOps))
                                     (ctrlop (assoc (car code) lit&ctrlOps)))
                                 (if byteop
                                     (let ((args (cadr byteop))
                                           (basecode (caddr byteop)))
                                       (set! new-code
                                             (cond ((= 2 args) (string-append
                                                                basecode
                                                                (binary-string (caddr code) 1)
                                                                (binary-string (cadr code) 7)))
                                                   ((= 0 args) basecode)
                                                   (else (string-append basecode (binary-string (cadr code) 7))))))
                                     (if ctrlop
                                         (let ((argsize (cadr ctrlop))
                                               (basecode (caddr ctrlop)))
                                           (set! new-code
                                                 (if (= 0 argsize)
                                                     basecode
                                                     (string-append basecode (binary-string (cadr code) argsize)))))
                                         (error "fonction non trouve pour assemblage" (car code)))))))
                       (if (= 14 (string-length new-code))
                           (iter (+ 1 line) (string-append bin-code new-code))
                           (if (string=? "" new-code)
                               bin-code
                               (error "assembler builds incorrect code line - argument overflow ? " line new-code)))))))
      (iter 0 ""))))


(define hexfile
  (lambda ()
    (number->string (string->number (assemble program) 2) 16)))
