PORTB	EQU	0x06
PORTA	EQU	0x05
TRISA	EQU	0x85
TRISB	EQU	86
INTCON	EQU	0B
BACKUPW	EQU	20
TMP	EQU	0C
A	EQU	10
B	EQU	11
I	EQU	12
RES	EQU	13  ; A * B = RES

	ORG	0x000

index0	MOVLW	0
	MOVWF	TRISA ;<=> TRIS PORTA
	GOTO	start

	ORG	0x004

isr	MOVWF	BACKUPW
	MOVLW	FF
	MOVWF	PORTB
	NOP
	NOP
	CLRF	PORTB
	RETFIE

start	MOVLW	b'10010000' ; GIE and INTE
	MOVWF	INTCON      ;  ^

; Now, interrupt is enabled on RB0/INT,
; PORTA is OUTPUT and PORTB is INPUT

loop
	NOP  ; pour laisser le temps de rentrer les donnes...
	MOVF	PORTB, W
	MOVWF	A
	NOP
	MOVF	PORTB, W
	MOVWF	B
	CALL mult
	MOVLW	0
	TRIS PORTB
	MOVF	RES, W
	MOVWF	PORTB
	MOVLW	FF
	TRIS	PORTB
	GOTO	loop

; la multiplication :
; pour b != 0
; ne modifie pas A et B, utilise I
; resultat dans RES.
mult
	MOVF	A, W
	MOVWF	I
	MOVLW	0
	MOVWF	RES
mult-loop	MOVF	B, W
	ADDWF	RES, F
	DECFSZ	I, F
	GOTO	mult-loop
	RETLW	0
