; TRIS = 0  =>  OUTPUT
; TRIS = 1  =>  INPUT

; the frame for inputs
(define inputs-frame
  (instantiate frame% ()
    (label "- INPUTS -")))

; what to do when a box is checked
(define input-callback
  (lambda (o e)
    (let ((boite (send o get-label)) (port 0) (bit 0))
      (if (char=? #\A (string-ref boite 0))
          (set! port 5)
          (set! port 6))
      (set! bit (string->number (substring boite 1 2)))
      (if (send o get-value)
          (bit-set! bit port)
          (bit-clear! bit port))
      (refresh-ports) ; so we see it in the main frame
      (send $canvas refresh))))


(define vpanel-inputs
  (instantiate vertical-panel% () (parent inputs-frame)))

(define hpanel-A
  (instantiate horizontal-panel% () (parent vpanel-inputs) (min-height 40)))

(define hpanel-B
  (instantiate horizontal-panel% () (parent vpanel-inputs) (min-height 40)))


(define a-boxes (make-vector 5))
(define b-boxes (make-vector 8))

; fill vectors with check-box%
(define build-box
  (lambda (port)
    (if (string=? port "A")
        ; I set "A0" or "B0" as label because if i do not, spaces between boxes are not created
        (instantiate check-box% () (label "A0")
          (parent hpanel-A) (enabled #f) (value #f) (callback input-callback))
        (instantiate check-box% () (label "B0")
          (parent hpanel-B) (enabled #f) (value #f) (callback input-callback)))))
                                                                                       
; set labels of check-boxes
(letrec ((put-names
          (lambda (port boxes i)
            (if (< i 0)
                (void)
                (begin (vector-set! boxes i (build-box port))
                       (send (vector-ref boxes i) set-label (string-append port (number->string i)))
                       (put-names port boxes (- i 1)))))))
  (put-names "A" a-boxes 4)
  (put-names "B" b-boxes 7))

; called by future presses of INPUTS button, refreshed states of the boxes.
(define refresh-i/o
  (lambda ()
    (letrec ((refresh-loop
              (lambda (boxes tris port i)
                (if (< i 0)
                    (void)
                    (begin (send (vector-ref boxes i) enable (is-bit-set? i tris))
                           (send (vector-ref boxes i) set-value (is-bit-set? i port))
                           (refresh-loop boxes tris port (- i 1)))))))
      (refresh-loop a-boxes TRISA (PORTA) 4)
      (refresh-loop b-boxes TRISB (PORTB) 7))))
