; encoding of PIC16f8x commands

; list: (mnemonic opcode)
; full word length is 14 bits.

; bit oriented file register operations begins with 'B'
; ALL TAKE 3 BITS FOR b AND 7 FOR f
(define bitOps
  '((BCF "0100")
    (BSF "0101")
    (BTFSC "0110")
    (BTFSS "0111")))

; byte oriented file register operations
; cadr is number of args
; if args, at least f:7 and if 2 args, there is d:1 before
(define ByteOps
  '((ADDWF 2 "000111")
    (ANDWF 2 "000101")
    (CLRF 1 "0000011")
    (CLRW 0 "00000100000000")
    (COMF 2 "001001")
    (DECF 2 "000011")
    (DECFSZ 2 "001011")
    (INCF 2 "001010")
    (INCFSZ 2 "001111")
    (IORWF 2 "000100")
    (MOVF 2 "001000")
    (MOVWF 1 "0000001")
    (NOP 0 "00000000000000")
    (OPTION 0 "00000001100010")
    (RLF 2 "001101")
    (RRF 2 "001100")
    (SUBWF 2 "000010")
    (SWAPF 2 "001110")
    (XORWF 2 "000110")))

; literal and control operations
; cadr is length of args
(define lit&ctrlOps
  '((ADDLW 8 "111111")
    (ANDLW 8 "111001")
    (CALL 11 "100")
    (CLRWDT 0 "00000001100100")
    (GOTO 11 "101")
    (IORLW 8 "111000")
    (MOVLW 8 "110011")
    (RETFIE 0 "00000000001001")
    (RETLW 8 "110111")
    (RETURN 0 "00000000001000")
    (SLEEP 0 "00000001100011")
    (SUBLW 8 "111101")
    (TRIS 3 "00000001100")
    (XORLW 8 "111010")))
